dnl $superduper: acinclude.m4,v 1.10 2001/10/26 19:52:05 samc Exp $
dnl Custom macros for use with juked

AC_DEFUN(AC_WITH_MYSQL,[
  AC_MSG_CHECKING(for MySQL support)
  AC_ARG_WITH(mysql,
  [  --with-mysql[=DIR]      Specify the locate of the MySQL libs and headers, defaults
                           to searching through a number of common places.],
  [ AC_FIND_MYSQL($withval) ],
  [ AC_FIND_MYSQL(yes) ])
  
  if test -z "$MYSQL_INCDIR"; then
    AC_MSG_RESULT(no)
  else
    MYSQL_CFLAGS="-I$MYSQL_INCDIR"
    MYSQL_LIBS="-L$MYSQL_LIBDIR -lmysqlclient"
    AC_MSG_RESULT(using $MYSQL_INCDIR)
  fi
])

AC_DEFUN(AC_FIND_MYSQL,[
  if test "$1" = "yes"; then
    if test -f /usr/include/mysql/mysql.h; then
      MYSQL_INCDIR=/usr/include/mysql
      MYSQL_LIBDIR=/usr/lib/mysql
    elif test -f /usr/include/mysql.h; then
      MYSQL_INCDIR=/usr/include
      MYSQL_LIBDIR=/usr/lib
    elif test -f /usr/local/include/mysql/mysql.h; then
      MYSQL_INCDIR=/usr/local/include/mysql
      MYSQL_LIBDIR=/usr/local/lib/mysql
    elif test -f /usr/local/include/mysql.h; then
      MYSQL_INCDIR=/usr/local/include
      MYSQL_LIBDIR=/usr/local/lib
    elif test -f /usr/local/mysql/include/mysql/mysql.h; then
      MYSQL_INCDIR=/usr/local/mysql/include/mysql
      MYSQL_LIBDIR=/usr/local/mysql/lib/mysql
    else
      MYSQL_INCDIR=""
      MYSQL_LIBDIR=""
    fi
  else 
    if test "$1" != "no"; then
      if test -f $withval/include/mysql/mysql.h; then
        MYSQL_INCDIR=$withval/include/mysql
        MYSQL_LIBDIR=$withval/lib/mysql
      elif test -f $withval/include/mysql.h; then
        MYSQL_INCDIR=$withval/include
        MYSQL_LIBDIR=$withval/lib
      else
        MYSQL_INCDIR=""
        MYSQL_LIBDIR=""
      fi
    fi
  fi
])
