#!/usr/bin/perl 
# $superduper: add_tracks.pl,v 1.3 2001/05/11 15:33:29 samc Exp $
# juked - a jukebox daemon
# Copyright (C) 2000 Sam Clegg - See COPYING
#
# Insert the given MP3 files into the local datadase.
# 
use DBI;
use MP3::Info; 
use Getopt::Std;
use IO::Handle;

my $new_count = 0;
my $bad_count = 0;
my $verbose   = 1;
my $force     = 0;
my $bad_dir_name = "bad name/";
my $dbserver  = "god";
my $dbname    = "juked";
my $dbuser    = "juked";
my $dbpass    = "juke";
my $query;
my $cursor;

sub addtodb;
sub print_usage;
sub message;
sub finishup;

if (!getopts('rvfs:d:u:p:'))
{
  print_usage();
  exit(-1);
}

#
# process cmd line args.
#
if ($opt_v) { $verbose++; }  
if ($opt_f) { $force = 1; }
if ($opt_s) { $dbserver = $opt_s; }
if ($opt_u) { $dbuser   = $opt_u; }
if ($opt_p) { $dbpass   = $opt_p; }
if ($opt_d) { $dbname   = $opt_d; }
my $dbh = DBI->connect("DBI:mysql:$dbname:$dbserver",$dbuser,$dbpass) or die $DBI::errstr;
if ($opt_r) 
  { 
    $query = "DELETE FROM tracks";
    $c = 'y';
    if (!$force)
      {
	print "Are you sure you want to empty the database first? [y/N] : ";
        $c = getc;
        if ($c != 'y' && $c != 'Y') { $c = 'n' };
      }
    if ($c == 'y' || $c == 'Y')
      {
        message("Deleting all records from database(!)\n",1);
        $cursor=$dbh->prepare($query);
        $cursor->execute();
      }
  }

#
# Process files given on cmd line.
#
if (@ARGV == 0)
  {
    message("No files given : adding files from current directory\n",1);
    @file_names = <*.{mp3,MP3}>;
  }
else
  {
    @file_names = @ARGV;
  }

my $num   = @file_names;
my $count = 0;
message("selected $num file(s) for addition\n",1);
$num = $num / 78;
STDOUT->autoflush(1);
message("[",1);
foreach $file (@file_names)
{
  chomp($file);
  addtodb($file);
  if ($count >= $num) 
    { 
      $count = 0; 
      message(".",1);
    }
  $count++;
}
message("]\n",1);
STDOUT->autoflush(1);

#
# Finished
#
finishup();
exit(0);

sub finishup
{
  if ($new_count) { message("added " . $new_count . " new tracks.\n",0); }
  if ($bad_count) { message("moved " . $bad_count . " moved to  $bad_dir_name\n",0); }
  if ($cursor) { $cursor->finish() };
  $dbh->disconnect;
}

sub message
{
  if ($verbose >= $_[1]) { print "$_[0]"; };
}

sub addtodb
{
  $file = $_[0];
  $query = "SELECT * FROM tracks WHERE filename = \"$file\"";
  $cursor=$dbh->prepare($query);
  $cursor->execute();
  @rows = $cursor->fetchrow;
  if (@rows == 0) 
    {
      my $info = get_mp3info($file);
      my $tag  = get_mp3tag ($file);
      if (!$tag || $tag->{ARTIST} eq "") 
	{ 
	  $newname = $bad__dir_name . $file;
	  message("bad ID3 tag : moving file : $file\n",1);
	  rename $file, $newname;
	  $bad_name++;
	} 
      else 
	{
	  foreach $key (keys %$tag) 
	    {
	      if ($tag->{$key}) {
		  $tag->{$key} =~ s/"/'/g;
	      } else {
		  $tag->{$key} = ""; 
	      }
	    }
	  foreach $key (keys %$info) 
	    {
	      if (!$info->{$key}) 
		{
		  $info->{$key} = ""; 
		}
	    }
	  @stats = stat($file);
	  $filesize = @stats[7];
	  $query = "INSERT INTO tracks (filename, filesize, artist, album, title, genre, tracknum, comment, length) \
                    VALUES (\"$file\",$filesize, \
                    \"$tag->{ARTIST}\",\"$tag->{ALBUM}\",\"$tag->{TITLE}\",\"$tag->{GENRE}\", \
                    \"$tag->{TRACKNUM}\",\"$tag->{COMMENT}\",\"00:$info->{MM}:$info->{SS}\")";
	  $cursor=$dbh->prepare($query);
	  $cursor->execute();
	  $new_count++;
	}
    }
}

sub print_usage
{
  print "usage : add_tracks.pl [options] [files]\n";
  print "Options are:\n";
  print "\t-v\t\tincrease verbosity (up to 3)\n";
  print "\t-r\t\tempty the database of ALL records before adding any\n";
  print "\t-f\t\tforce : don't ask before emptying\n";
  print "\t-s <dbserv>\tUse <dbserv> as the database server.\n";
  print "\t-d <dbname>\tUse <dbname> as the database name.\n";
  print "\t-u <dbuser>\tUse <dbuser> as the database user.\n";
  print "\t-p <dbpass>\tUse <dbpass> as the database password.\n";
  print "\nIf no files are specified all .MP3 files in the cwd are used\n";
}
