/*
 * juked - a jukebox daemon
 * Copyright (C) 2000-2002 Sam Clegg - See COPYING
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  
 * Functions called by the parser to excecute commands.
 *
 * $superduper: commands.h,v 1.19 2002/04/20 10:54:59 samc Exp $
 */
#ifndef COMMANDS_H
#define COMMANDS_H

/* commands that optionally generate output */
void cmd_play    (int output, int id);
void cmd_add     (int output, int id);
void cmd_remove  (int output, int id);
void cmd_stop    (int output);
void cmd_pause   (int output);
void cmd_next    (int output);
void cmd_prev    (int output);
void cmd_quit    (int output);
void cmd_random  (int output);
void cmd_autoskip(int output);

/* commands that always generate output */
void cmd_user    (char* username);
void cmd_pass    (char* password);
void cmd_find    (char* field, char* string);
void cmd_info    (int id);
void cmd_version ();
void cmd_list    ();
void cmd_help    ();
void cmd_status  ();
void cmd_history ();
void cmd_artists ();
  
#endif /* !COMMANDS_H */
