/*
 * juked - a jukebox daemon
 * Copyright (C) 2000-2002 Sam Clegg - See COPYING
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  
 * Public database access functions.
 * All functions return 0 on success and -1 on error except "db_is_valid_id" 
 * which returns 1 when given a valid ID and 0 otherwise 
 *
 * $superduper: database.h,v 1.16 2002/04/20 10:54:59 samc Exp $
 */
#ifndef DATABASE_H
#define DATABASE_H

int init_database ();

int (*term_database)    ();
int (*db_is_valid_id)   (int track_id);
int (*db_get_filename)  (int track_id, char *filename);
int (*db_get_random_id) ();
xmlDocPtr (*db_search)  (char *field, char *string);
xmlDocPtr (*db_lookup)  (int track_id);
xmlDocPtr (*db_list)    (int track_id);

#endif /* !DATABASE_H */
