/*
 * juked - a jukebox daemon 
 * Copyright (C) 2000-2002 Sam Clegg - See COPYING
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *    
 * mpg123 playback function headers.
 * These never get called directly.  They are linked
 * to the general player funstions when used.
 *
 * $superduper: mpglib.c,v 1.2 2002/04/27 18:38:10 samc Exp $
 */
#include <mpglib/mpg123.h>
#include <mpglib/mpglib.h>

static struct mpstr mpg123_stream;

int
mpglib_init ()
{
  if (!InitMP3 (&mpg123_stream))
    {
      return -1;
    }

  return 0;
}

int
mpglib_term ()
{
  ExitMP3 (&mpg123_stream);
  return 0;
}

int
mpglib_decode (char *bufin, char *bufout, int inlen, int outlen, int *result)
{
  int len = 0;
  int rtn = MP3_OK;
  *result = 0;

  if (bufin)
    {
      /* add the input buffer to the stream */
      rtn = decodeMP3 (&mpg123_stream,
          bufin, inlen,
          bufout, outlen,
          &len);
    }
  else
    { 
      /* keep deocding till we run out of output space or input data */
      rtn = decodeMP3 (&mpg123_stream,
          NULL, 0,
          bufout, outlen,
          &len);
    } 
  *result += len;

  if (rtn != MP3_OK) return -1;
  else               return  0;
}
