/*
 * juked - a jukebox daemon
 * Copyright (C) 2000-2002 Sam Clegg - See COPYING
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  
 * $superduper: settings.h,v 1.15 2002/05/01 11:37:38 samc Exp $
 */
#ifndef SETTINGS_H
#define SETTINGS_H

/** settings struct */
typedef struct 
{
  char *device;
  char *rcfile;
  char *mp3root;
  char *db_type;
  char *db_name;
  char *db_user;
  char *db_pass;
  char *db_server;
  char *history_file;
  char *pwdfile;
  char *decoder;
  int   port;
  int   max_connections;
  int   backlog;
  int   autoskip;
  int   autostart;
  int   usepam;
  int   random;
  int   log_history;
  int   log_level;
  int   use_syslog;
  int   want_core;
  int   daemon;
  int   human;
} settings_t;

/** singleton instance of settings_t*/
extern settings_t settings;

/**
 * Settings are undefined utill init_settings is called.
 * This will set default values and read in rcfiles.
 */
int init_settings ();

/** Free all the settings */
void term_settings ();

/**
 * Set a settings string value.
 * This does malloc/free so you don't have to.
 */
int settings_setvalue (const char* name, const char *new_value);

/**
 * Write the current settings back to the disk
 * as XML.
 */
int settings_write ();

#endif /* !SETTINGS_H */
